# Xorfilter: Rust xor filter implementation

[Original authors](https://github.com/FastFilter/xorfilter) abstract: Bloom filters are used to quickly check whether an element is part of a set. Xor filters are a faster and more concise alternative to Bloom filters. They are also smaller than cuckoo filters.

## API

```rust
use Xorfilter::{XorFilter};

fn main() {

    // create filter // default Xor8
    let mut x = XorFilter::new();
   
    let keys = vec![1, 2, 3];

    // populate keys
    x.populate(&keys);

    // check if key is in the filter 
    for key in &keys {
        println!("{}", x.contains(*key));
    }

}
```
## Status

Currently only supports Xor8. Working on trait to extend filters based on [Xorf](https://crates.io/crates/xorf). 

## Reference

[Xor Filters: Faster and Smaller Than Bloom and Cuckoo
Filters](https://arxiv.org/abs/1912.08258), Journal of Experimental
Algorithmics.

